# -*- coding: utf8 -*-
from __future__ import unicode_literals

parser_class = "altostar"


def test_decode_result(self):
    worklist = self.decode(
        """
        ,Well,Fluor,Target,Content,Sample,Biological Set Name,Cq,Cq Mean,Cq Std. Dev,Starting Quantity (SQ),Log Starting Quantity,SQ Mean,SQ Std. Dev,Set Point,Well Note
    ,A01,FAM,CMV,NTC,NTC | 104208171912,AltoStar CMV PCR Kit 1.5,NaN,0,0,NaN,NaN,0,0,58,
    ,A02,FAM,CMV,Unkn,Sample 4 | 00000004,AltoStar CMV PCR Kit 1.5,NaN,0,0,NaN,NaN,0,0,58,qualitative
    ,A01,VIC,Internal Control,NTC,NTC | 104208171912,AltoStar CMV PCR Kit 1.5,26.7753769801243,26.7753769801243,0,NaN,NaN,NaN,0,58,
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "rack": "ALTOSTAR-A01",
                "results": [
                    {"code": "FAMCMVCq", "value": "NaN"},
                    {"code": "FAMCMVCq Mean", "value": "0"},
                    {"code": "FAMCMVCq Std. Dev", "value": "0"},
                    {"code": "FAMCMVStarting Quantity (SQ)", "value": "NaN"},
                    {"code": "FAMCMVLog Starting Quantity", "value": "NaN"},
                    {"code": "FAMCMVSQ Mean", "value": "0"},
                    {"code": "FAMCMVSQ Std. Dev", "value": "0"},
                    {"code": "FAMCMVSet Point", "value": "58"},
                    {"code": "FAMCMVWell Note", "value": ""},
                ],
                "sample_id": "104208171912",
                "type": "patient",
            },
            {
                "rack": "ALTOSTAR-A02",
                "results": [
                    {"code": "FAMCMVCq", "value": "NaN"},
                    {"code": "FAMCMVCq Mean", "value": "0"},
                    {"code": "FAMCMVCq Std. Dev", "value": "0"},
                    {"code": "FAMCMVStarting Quantity (SQ)", "value": "NaN"},
                    {"code": "FAMCMVLog Starting Quantity", "value": "NaN"},
                    {"code": "FAMCMVSQ Mean", "value": "0"},
                    {"code": "FAMCMVSQ Std. Dev", "value": "0"},
                    {"code": "FAMCMVSet Point", "value": "58"},
                    {"code": "FAMCMVWell Note", "value": "qualitative"},
                ],
                "sample_id": "00000004",
                "type": "patient",
            },
            {
                "rack": "ALTOSTAR-A01",
                "results": [
                    {"code": "VICInternal ControlCq", "value": "26.7753769801243"},
                    {"code": "VICInternal ControlCq Mean", "value": "26.7753769801243"},
                    {"code": "VICInternal ControlCq Std. Dev", "value": "0"},
                    {
                        "code": "VICInternal ControlStarting Quantity (SQ)",
                        "value": "NaN",
                    },
                    {
                        "code": "VICInternal ControlLog Starting Quantity",
                        "value": "NaN",
                    },
                    {"code": "VICInternal ControlSQ Mean", "value": "NaN"},
                    {"code": "VICInternal ControlSQ Std. Dev", "value": "0"},
                    {"code": "VICInternal ControlSet Point", "value": "58"},
                    {"code": "VICInternal ControlWell Note", "value": ""},
                ],
                "sample_id": "104208171912",
                "control_lot": "104208171912",
                "type": "control",
            },
        ],
    }
    assert worklist == expected
