# -*- coding: utf8 -*-
from __future__ import unicode_literals

parser_class = "blotrix_recomscan"


def test_encode_order(self):
    _order = """;;;;;;"Patient";A;;"036666666";"NYME";"ANO";13.05.2011;"123456";;;0;0;0;
    ;;;;;;"Patient";B;;"036666666";"NYME";"ANO";13.05.2011;"123456";;;0;0;0;"""
    message = self.order()
    assert message == _order


def test_decode_result(self):
    self.configure(ignore_resultat_absent=True)
    worklist = self.decode(
        """No;Company;TypeOfTest;Revision;Control;Ig-Type;Charge;Strip-Type;CW;Sample No.;PID;LastName;FirstName;Birthday;Sex;ElisaIgA;ElisaIgG;ElisaIgM;DateOfRequest;DateOfAnalysis;CutOffTolerance;rShort;Result;rjoined;Antigens;Rev.Antigens;WindowsUser;CheckSum;ReaktKontr-I ;ReaktKontr%CO ;ReaktKontr-A ;ReaktKontr-R  ;IgG-I ;IgG%CO ;IgG-A ;IgG-R  ;IgM-I ;IgM%CO ;IgM-A ;IgM-R  ;CutOff-I ;CutOff%CO ;CutOff-A ;CutOff-R  ;p100-I ;p100%CO ;p100-A ;p100-R  ;VlsE-I ;VlsE%CO ;VlsE-A ;VlsE-R  ;p58-I ;p58%CO ;p58-A ;p58-R  ;p41-I ;p41%CO ;p41-A ;p41-R  ;p39-I ;p39%CO ;p39-A ;p39-R  ;OspA-I ;OspA%CO ;OspA-A ;OspA-R  ;OspCBss-I ;OspCBss%CO ;OspCBss-A ;OspCBss-R  ;OspCBaf-I ;OspCBaf%CO ;OspCBaf-A ;OspCBaf-R  ;OspCBga-I ;OspCBga%CO ;OspCBga-A ;OspCBga-R  ;OspCBsp-I ;OspCBsp%CO ;OspCBsp-A ;OspCBsp-R  ;p18Bss-I ;p18Bss%CO ;p18Bss-A ;p18Bss-R  ;p18Baf-I ;p18Baf%CO ;p18Baf-A ;p18Baf-R  ;p18Bg1-I ;p18Bg1%CO ;p18Bg1-A ;p18Bg1-R  ;p18Bg2-I ;p18Bg2%CO ;p18Bg2-A ;p18Bg2-R  ;p18Bsp-I ;p18Bsp%CO ;p18Bsp-A ;p18Bsp-R
1;Mikrogen;recomLine Borrelia;1; ;IgM ;n.a. ;Patient;n.a. ;70clarisys01;26014;TEST;MCA;n.a. ;n.a. ;n.a.;n.a.;n.a.;10.11.2017; ;-15;"negative;0point(s)";negative;n.a. ;n.a. ;n.a. ;ALLDIAG;n.a. ;392;0;1678;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;240;0;952;n.a. ;23,2;0;143;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. ;n.a. """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "results": [
                    {"code": "IgM_rShort", "value": "negative;0point(s)"},
                    {"code": "IgM_Result", "value": "negative"},
                    {"code": "IgM_ReaktKontr-I", "value": "392"},
                    {"code": "IgM_ReaktKontr%CO", "value": "0"},
                    {"code": "IgM_ReaktKontr-A", "value": "1678"},
                    {"code": "IgM_IgM-I", "value": "240"},
                    {"code": "IgM_IgM%CO", "value": "0"},
                    {"code": "IgM_IgM-A", "value": "952"},
                    {"code": "IgM_CutOff-I", "value": "23.2"},
                    {"code": "IgM_CutOff%CO", "value": "0"},
                    {"code": "IgM_CutOff-A", "value": "143"},
                ],
                "sample_id": "70clarisys01",
                "type": "patient",
            }
        ],
    }
    assert worklist == expected
