# -*- coding: utf8 -*-

from __future__ import unicode_literals

from driverng.tests import BaseTest


class PvsTest(BaseTest):
    PROTOCOL_CLASS = "pvs"

    def test_send_recv(self):
        self.assertSendRecvMessageEqual(
            """
        TYP:RQ|SID:123456|NAM:NYME_ANO|MAT:Seru|TST:Serum,A,B|""",
            """
        send <stx>FN:00|TYP:RQ|SID:123456|NAM:NYME_ANO|MAT:Seru|TST:Serum,A,B|<cr><lf>D1<etx>
        recv <stx>
        recv FN:02|TYP:ACK|CHK:D1|<cr><lf>EE<etx>
        """,
        )

    def test_recv(self):
        self.assertRecvMessageEqual(
            """
            recv <stx>
            recv FN:11|TYP:LA|SID:0473|<cr><lf>B9<etx>
            send <stx>FN:00|TYP:ACK|CHK:BC|<cr><lf>E3<etx>
            """,
            """TYP:LA|SID:0473|""",
        )

    def test_send_recv_frame(self):
        self.assertSendRecvMessageEqual(
            """
        TYP:RQ|SID:123456|NAM:NYME_ANO|MAT:Seru|TST:Serum,A,B|""",
            """
        send <stx>FN:00|TYP:RQ|SID:123456|NAM:NYME_ANO|MAT:Seru|TST:Serum,A,B|<cr><lf>D1<etx>
        recv <stx>
        recv FN:14|TYP:WP|SID:101507181233|WRK:ARC-01|TRG:1|POS:2-4|TST:ARC-01|ALQ: 0|SYS:01|<cr><lf>A2<etx>
        send <stx>FN:01|TYP:ACK|CHK:A2|<cr><lf><etx>
        """,
        )
